# Method: projects.locations.environments.saveSnapshot

- [HTTP request](https://docs.cloud.google.com/composer/docs/reference/rest/v1/projects.locations.environments/saveSnapshot#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/composer/docs/reference/rest/v1/projects.locations.environments/saveSnapshot#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/composer/docs/reference/rest/v1/projects.locations.environments/saveSnapshot#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/composer/docs/reference/rest/v1/projects.locations.environments/saveSnapshot#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/composer/docs/reference/rest/v1/projects.locations.environments/saveSnapshot#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/composer/docs/reference/rest/v1/projects.locations.environments/saveSnapshot#body.aspect)
- [Try it!](https://docs.cloud.google.com/composer/docs/reference/rest/v1/projects.locations.environments/saveSnapshot#try-it)

Creates a snapshots of a Cloud Composer environment.

As a result of this operation, snapshot of environment's state is stored in a location specified in the SaveSnapshotRequest.

### HTTP request

`POST https://composer.googleapis.com/v1/{environment=projects/*/locations/*/environments/*}:saveSnapshot`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `environment` | `string` The resource name of the source environment in the form: "projects/{projectId}/locations/{locationId}/environments/{environmentId}" Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `environment`: - `composer.environments.update` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "snapshotLocation": string } ``` |

| Fields ||
|---|---|
| `snapshotLocation` | `string` Location in a Cloud Storage where the snapshot is going to be stored, e.g.: "gs://my-bucket/snapshots". |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/composer/docs/reference/rest/Shared.Types/ListOperationsResponse#Operation`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloudcomposer`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).